---
title: Creating and triggering events
slug: Web/Guide/Events/Creating_and_triggering_events
tags:
  - Advanced
  - DOM
  - Guide
  - JavaScript
  - NeedsContent
  - events
---
<p>This article demonstrates how to create and dispatch DOM events. Such events are commonly called <strong>synthetic events</strong>, as opposed to the events fired by the browser itself.</p>

<h2 id="Creating_custom_events">Creating custom events</h2>

<p>Events can be created with the <a href="/en-US/docs/Web/API/Event"><code>Event</code></a> constructor as follows:</p>

<pre class="brush: js notranslate">const event = new Event('build');

// Listen for the event.
elem.addEventListener('build', function (e) { /* ... */ }, false);

// Dispatch the event.
elem.dispatchEvent(event);</pre>

<p>The above code example uses the <a href="/en-US/docs/Web/API/EventTarget/dispatchEvent">EventTarget.dispatchEvent()</a> method.</p>

<p>This constructor is supported in most modern browsers (with Internet Explorer being the exception). For a more verbose approach (which works with Internet Explorer), see <a href="#The_old-fashioned_way">the old-fashioned way</a> below.</p>

<h3 id="Adding_custom_data_–_CustomEvent">Adding custom data – CustomEvent()</h3>

<p>To add more data to the event object, the <a href="/en-US/docs/Web/API/CustomEvent">CustomEvent</a> interface exists and the <u><strong>detail</strong></u> property can be used to pass custom data.<br>
 <span style="line-height: 1.5;">For example, the event could be created as follows:</span></p>

<pre class="brush: js notranslate">const event = new CustomEvent('build', { detail: elem.dataset.time });</pre>

<p>This will then allow you to access the additional data in the event listener:</p>

<pre class="brush: js notranslate">function eventHandler(e) {
  console.log('The time is: ' + e.detail);
}
</pre>

<h3 id="The_old-fashioned_way">The old-fashioned way</h3>

<p>The older approach to creating events uses APIs inspired by Java. The following shows an example with {{domxref("document.createEvent()")}}:</p>

<pre class="brush: js notranslate">// Create the event.
const event = document.createEvent('Event');

// Define that the event name is 'build'.
event.initEvent('build', true, true);

// Listen for the event.
elem.addEventListener('build', function (e) {
  // e.target matches elem
}, false);

// target can be any Element or other EventTarget.
elem.dispatchEvent(event);

</pre>

<h3 id="Event_bubbling">Event bubbling</h3>

<p>It is often desirable to trigger an event from a child element, and have an ancestor catch it; optionally, with data:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;textarea&gt;&lt;/textarea&gt;
&lt;/form&gt;
</pre>

<pre class="brush: js notranslate">const form = document.querySelector('form');
const textarea = document.querySelector('textarea');

// Create a new event, allow bubbling, and provide any data you want to pass to the "detail" property
const eventAwesome = new CustomEvent('awesome', {
  bubbles: true,
  detail: { text: () =&gt; textarea.value }
});

// The form element listens for the custom "awesome" event and then consoles the output of the passed text() method
form.addEventListener('awesome', e =&gt; console.log(e.detail.text()));

// As the user types, the textarea inside the form dispatches/triggers the event to fire, and uses itself as the starting point
textarea.addEventListener('input', e =&gt; e.target.dispatchEvent(eventAwesome));
</pre>

<h3 id="Creating_and_dispatching_events_dynamically">Creating and dispatching events dynamically</h3>

<p>Elements can listen for events that haven't been created yet:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;textarea&gt;&lt;/textarea&gt;
&lt;/form&gt;
</pre>

<pre class="brush: js notranslate">const form = document.querySelector('form');
const textarea = document.querySelector('textarea');

form.addEventListener('awesome', e =&gt; console.log(e.detail.text()));

textarea.addEventListener('input', function() {
  // Create and dispatch/trigger an event on the fly
  // Note: Optionally, we've also leveraged the "function expression" (instead of the "arrow function expression") so "this" will represent the element
  this.dispatchEvent(new CustomEvent('awesome', { bubbles: true, detail: { text: () =&gt; textarea.value } }))
});
</pre>

<h2 id="Triggering_built-in_events">Triggering built-in events</h2>

<p>This example demonstrates simulating a click (that is programmatically generating a click event) on a checkbox using DOM methods. <a class="external" href="http://developer.mozilla.org/samples/domref/dispatchEvent.html">View the example in action.</a></p>

<pre class="brush: js notranslate">function simulateClick() {
  const event = new MouseEvent('click', {
    view: window,
    bubbles: true,
    cancelable: true
  });
  const cb = document.getElementById('checkbox');
  const cancelled = !cb.dispatchEvent(event);

  if (cancelled) {
    // A handler called preventDefault.
    alert("cancelled");
  } else {
    // None of the handlers called preventDefault.
    alert("not cancelled");
  }
}</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CustomEvent/CustomEvent">CustomEvent()</a></li>
 <li>{{domxref("document.createEvent()")}}</li>
 <li>{{domxref("Event.initEvent()")}}</li>
 <li>{{domxref("EventTarget.dispatchEvent()")}}</li>
 <li>{{domxref("EventTarget.addEventListener()")}}</li>
</ul>
